// [!output PROJECT_NAME].cpp : mex-function interface implentation file


#include "itpp/itcomm.h"
#include "itpp/comm/modulatord.h"
#include "itpp/itmex.h"
using namespace itpp;


void mexFunction( int nlhs, mxArray *plhs[], 
		  int nrhs, const mxArray*prhs[] ) 
{ 
    //Modulation 16DAPSK, tableau de bits venant de MATLAB

	cvec output_symbols;
	double al,ah,lt,ht;

	// Check the number of inputs and output arguments
    if(nlhs!=1) mexErrMsgTxt("Wrong number of output variables !");
    if(nrhs!=5) mexErrMsgTxt("Wrong number of input variables !");

    // Convert input variables to IT++ format
	al = mxArray2double(prhs[0]);
    ah = mxArray2double(prhs[1]);
	lt = mxArray2double(prhs[2]);
	ht = mxArray2double(prhs[3]);

    D2A8PSK dpsk(al, ah, lt, ht);

    bvec input_bits = mxArray2bvec(prhs[4]);

	output_symbols = dpsk.modulate_bits(input_bits);

	// Create output vectors
    plhs[0] = mxCreateDoubleMatrix(1,output_symbols.size(), mxCOMPLEX);

    // Convert the IT++ format to Matlab format for output
    cvec2mxArray(output_symbols, plhs[0]);

    return;
}


